// Package v2 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.8.2 DO NOT EDIT.
package v2

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
)

const (
	BearerScopes = "Bearer.Scopes"
)

// Defines values for AzureUploadOptionsHyperVGeneration.
const (
	AzureUploadOptionsHyperVGenerationV1 AzureUploadOptionsHyperVGeneration = "V1"

	AzureUploadOptionsHyperVGenerationV2 AzureUploadOptionsHyperVGeneration = "V2"
)

// Defines values for BlueprintCustomizationsPartitioningMode.
const (
	BlueprintCustomizationsPartitioningModeAutoLvm BlueprintCustomizationsPartitioningMode = "auto-lvm"

	BlueprintCustomizationsPartitioningModeLvm BlueprintCustomizationsPartitioningMode = "lvm"

	BlueprintCustomizationsPartitioningModeRaw BlueprintCustomizationsPartitioningMode = "raw"
)

// Defines values for ComposeStatusValue.
const (
	ComposeStatusValueFailure ComposeStatusValue = "failure"

	ComposeStatusValuePending ComposeStatusValue = "pending"

	ComposeStatusValueSuccess ComposeStatusValue = "success"
)

// Defines values for CustomizationsPartitioningMode.
const (
	CustomizationsPartitioningModeAutoLvm CustomizationsPartitioningMode = "auto-lvm"

	CustomizationsPartitioningModeLvm CustomizationsPartitioningMode = "lvm"

	CustomizationsPartitioningModeRaw CustomizationsPartitioningMode = "raw"
)

// Defines values for ImageSBOMPipelinePurpose.
const (
	ImageSBOMPipelinePurposeBuildroot ImageSBOMPipelinePurpose = "buildroot"

	ImageSBOMPipelinePurposeImage ImageSBOMPipelinePurpose = "image"
)

// Defines values for ImageSBOMSbomType.
const (
	ImageSBOMSbomTypeSpdx ImageSBOMSbomType = "spdx"
)

// Defines values for ImageStatusValue.
const (
	ImageStatusValueBuilding ImageStatusValue = "building"

	ImageStatusValueFailure ImageStatusValue = "failure"

	ImageStatusValuePending ImageStatusValue = "pending"

	ImageStatusValueRegistering ImageStatusValue = "registering"

	ImageStatusValueSuccess ImageStatusValue = "success"

	ImageStatusValueUploading ImageStatusValue = "uploading"
)

// Defines values for ImageTypes.
const (
	ImageTypesAws ImageTypes = "aws"

	ImageTypesAwsHaRhui ImageTypes = "aws-ha-rhui"

	ImageTypesAwsRhui ImageTypes = "aws-rhui"

	ImageTypesAwsSapRhui ImageTypes = "aws-sap-rhui"

	ImageTypesAzure ImageTypes = "azure"

	ImageTypesAzureEap7Rhui ImageTypes = "azure-eap7-rhui"

	ImageTypesAzureRhui ImageTypes = "azure-rhui"

	ImageTypesAzureSapRhui ImageTypes = "azure-sap-rhui"

	ImageTypesEdgeCommit ImageTypes = "edge-commit"

	ImageTypesEdgeContainer ImageTypes = "edge-container"

	ImageTypesEdgeInstaller ImageTypes = "edge-installer"

	ImageTypesGcp ImageTypes = "gcp"

	ImageTypesGcpRhui ImageTypes = "gcp-rhui"

	ImageTypesGuestImage ImageTypes = "guest-image"

	ImageTypesImageInstaller ImageTypes = "image-installer"

	ImageTypesIotBootableContainer ImageTypes = "iot-bootable-container"

	ImageTypesIotCommit ImageTypes = "iot-commit"

	ImageTypesIotContainer ImageTypes = "iot-container"

	ImageTypesIotInstaller ImageTypes = "iot-installer"

	ImageTypesIotRawImage ImageTypes = "iot-raw-image"

	ImageTypesIotSimplifiedInstaller ImageTypes = "iot-simplified-installer"

	ImageTypesLiveInstaller ImageTypes = "live-installer"

	ImageTypesMinimalRaw ImageTypes = "minimal-raw"

	ImageTypesOci ImageTypes = "oci"

	ImageTypesVsphere ImageTypes = "vsphere"

	ImageTypesVsphereOva ImageTypes = "vsphere-ova"

	ImageTypesWsl ImageTypes = "wsl"
)

// Defines values for UploadStatusValue.
const (
	UploadStatusValueFailure UploadStatusValue = "failure"

	UploadStatusValuePending UploadStatusValue = "pending"

	UploadStatusValueRunning UploadStatusValue = "running"

	UploadStatusValueSuccess UploadStatusValue = "success"
)

// Defines values for UploadTypes.
const (
	UploadTypesAws UploadTypes = "aws"

	UploadTypesAwsS3 UploadTypes = "aws.s3"

	UploadTypesAzure UploadTypes = "azure"

	UploadTypesContainer UploadTypes = "container"

	UploadTypesGcp UploadTypes = "gcp"

	UploadTypesLocal UploadTypes = "local"

	UploadTypesOciObjectstorage UploadTypes = "oci.objectstorage"

	UploadTypesPulpOstree UploadTypes = "pulp.ostree"
)

// AWSEC2CloneCompose defines model for AWSEC2CloneCompose.
type AWSEC2CloneCompose struct {
	Region            string    `json:"region"`
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// AWSEC2UploadOptions defines model for AWSEC2UploadOptions.
type AWSEC2UploadOptions struct {
	Region            string   `json:"region"`
	ShareWithAccounts []string `json:"share_with_accounts"`
	SnapshotName      *string  `json:"snapshot_name,omitempty"`
}

// AWSEC2UploadStatus defines model for AWSEC2UploadStatus.
type AWSEC2UploadStatus struct {
	Ami    string `json:"ami"`
	Region string `json:"region"`
}

// AWSS3UploadOptions defines model for AWSS3UploadOptions.
type AWSS3UploadOptions struct {
	// If set to false (the default value), a long, obfuscated URL
	// is returned. Its expiration might be sooner than for other upload
	// targets.
	//
	// If set to true, a shorter URL is returned and
	// its expiration is the same as for the other upload targets.
	Public *bool  `json:"public,omitempty"`
	Region string `json:"region"`
}

// AWSS3UploadStatus defines model for AWSS3UploadStatus.
type AWSS3UploadStatus struct {
	Url string `json:"url"`
}

// AzureUploadOptions defines model for AzureUploadOptions.
type AzureUploadOptions struct {
	// Choose the VM Image HyperV generation, different features on Azure are available
	// depending on the HyperV generation.
	HyperVGeneration *AzureUploadOptionsHyperVGeneration `json:"hyper_v_generation,omitempty"`

	// Name of the uploaded image. It must be unique in the given resource group.
	// If name is omitted from the request, a random one based on a UUID is
	// generated.
	ImageName *string `json:"image_name,omitempty"`

	// Location of the provided resource_group, where the image should be uploaded and registered.
	// How to list all locations:
	// https://docs.microsoft.com/en-us/cli/azure/account?view=azure-cli-latest#az_account_list_locations'
	// If the location is not specified, it is deducted from the provided resource_group.
	Location *string `json:"location,omitempty"`

	// Name of the resource group where the image should be uploaded.
	ResourceGroup string `json:"resource_group"`

	// ID of subscription where the image should be uploaded.
	SubscriptionId string `json:"subscription_id"`

	// ID of the tenant where the image should be uploaded.
	// How to find it in the Azure Portal:
	// https://docs.microsoft.com/en-us/azure/active-directory/fundamentals/active-directory-how-to-find-tenant
	TenantId string `json:"tenant_id"`
}

// Choose the VM Image HyperV generation, different features on Azure are available
// depending on the HyperV generation.
type AzureUploadOptionsHyperVGeneration string

// AzureUploadStatus defines model for AzureUploadStatus.
type AzureUploadStatus struct {
	ImageName string `json:"image_name"`
}

// Blueprint defines model for Blueprint.
type Blueprint struct {
	// Container images to embed into the final artfact
	Containers     *[]Container             `json:"containers,omitempty"`
	Customizations *BlueprintCustomizations `json:"customizations,omitempty"`
	Description    *string                  `json:"description,omitempty"`

	// The distribution to use for the compose. If left empty the host
	// distro will be used.
	Distro *string `json:"distro,omitempty"`

	// Package groups to be installed
	Groups *[]PackageGroup `json:"groups,omitempty"`

	// An alias for packages, retained for backwards compatability
	Modules *[]Package `json:"modules,omitempty"`
	Name    string     `json:"name"`

	// Packages to be installed
	Packages *[]Package `json:"packages,omitempty"`

	// A semver version number
	Version *string `json:"version,omitempty"`
}

// BlueprintCustomizations defines model for BlueprintCustomizations.
type BlueprintCustomizations struct {
	Cacerts *CACertsCustomization `json:"cacerts,omitempty"`

	// Directories to create in the final artifact
	Directories *[]Directory `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo *FDO `json:"fdo,omitempty"`

	// Files to create in the final artifact
	Files *[]BlueprintFile `json:"files,omitempty"`

	// List of filesystem mountpoints to create
	Filesystem *[]BlueprintFilesystem `json:"filesystem,omitempty"`

	// Enable FIPS mode
	Fips *bool `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *BlueprintFirewall `json:"firewall,omitempty"`

	// List of groups to create
	Group *[]Group `json:"group,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale            `json:"locale,omitempty"`
	Openscap *BlueprintOpenSCAP `json:"openscap,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *BlueprintCustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Repositories to write to /etc/yum.repos.d/ in the final image. Note
	// that these are not used at build time.
	Repositories *[]BlueprintRepository `json:"repositories,omitempty"`
	Rhsm         *RHSMCustomization     `json:"rhsm,omitempty"`
	Rpm          *RPMCustomization      `json:"rpm,omitempty"`
	Services     *Services              `json:"services,omitempty"`

	// List of ssh keys
	Sshkey *[]SSHKey `json:"sshkey,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`

	// List of users to create
	User *[]BlueprintUser `json:"user,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type BlueprintCustomizationsPartitioningMode string

// A custom file to create in the final artifact.
type BlueprintFile struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// BlueprintFilesystem defines model for BlueprintFilesystem.
type BlueprintFilesystem struct {
	// size of the filesystem in bytes
	Minsize    uint64 `json:"minsize"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type BlueprintFirewall struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
	Zones    *[]FirewallZones  `json:"zones,omitempty"`
}

// BlueprintOpenSCAP defines model for BlueprintOpenSCAP.
type BlueprintOpenSCAP struct {
	Datastream    *string                `json:"datastream,omitempty"`
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// BlueprintRepository defines model for BlueprintRepository.
type BlueprintRepository struct {
	Baseurls   *[]string `json:"baseurls,omitempty"`
	Enabled    *bool     `json:"enabled,omitempty"`
	Filename   *string   `json:"filename,omitempty"`
	Gpgcheck   *bool     `json:"gpgcheck,omitempty"`
	Gpgkeys    *[]string `json:"gpgkeys,omitempty"`
	Id         string    `json:"id"`
	Metalink   *string   `json:"metalink,omitempty"`
	Mirrorlist *string   `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool   `json:"module_hotfixes,omitempty"`
	Name           *string `json:"name,omitempty"`
	Priority       *int    `json:"priority,omitempty"`
	RepoGpgcheck   *bool   `json:"repo_gpgcheck,omitempty"`
	Sslverify      *bool   `json:"sslverify,omitempty"`
}

// BlueprintUser defines model for BlueprintUser.
type BlueprintUser struct {
	Description *string `json:"description,omitempty"`

	// Group id to use instead of the default
	Gid *int `json:"gid,omitempty"`

	// A list of additional groups to add the user to
	Groups *[]string `json:"groups,omitempty"`

	// The user's home directory
	Home *string `json:"home,omitempty"`

	// ssh public key
	Key  *string `json:"key,omitempty"`
	Name string  `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`

	// Login shell to use
	Shell *string `json:"shell,omitempty"`

	// User id to use instead of the default
	Uid *int `json:"uid,omitempty"`
}

// CACertsCustomization defines model for CACertsCustomization.
type CACertsCustomization struct {
	PemCerts []string `json:"pem_certs"`
}

// CloneComposeBody defines model for CloneComposeBody.
type CloneComposeBody interface{}

// CloneComposeResponse defines model for CloneComposeResponse.
type CloneComposeResponse struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// CloneStatus defines model for CloneStatus.
type CloneStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded struct due to allOf(#/components/schemas/UploadStatus)
	UploadStatus `yaml:",inline"`
}

// ComposeId defines model for ComposeId.
type ComposeId struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// ComposeLogs defines model for ComposeLogs.
type ComposeLogs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageBuilds []interface{} `json:"image_builds"`
	Koji        *KojiLogs     `json:"koji,omitempty"`
}

// ComposeManifests defines model for ComposeManifests.
type ComposeManifests struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Manifests []interface{} `json:"manifests"`
}

// ComposeMetadata defines model for ComposeMetadata.
type ComposeMetadata struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// ID (hash) of the built commit
	OstreeCommit *string `json:"ostree_commit,omitempty"`

	// Package list including NEVRA
	Packages *[]PackageMetadata `json:"packages,omitempty"`
}

// ComposeRequest defines model for ComposeRequest.
type ComposeRequest struct {
	Blueprint      *Blueprint      `json:"blueprint,omitempty"`
	Customizations *Customizations `json:"customizations,omitempty"`
	Distribution   string          `json:"distribution"`
	ImageRequest   *ImageRequest   `json:"image_request,omitempty"`
	ImageRequests  *[]ImageRequest `json:"image_requests,omitempty"`
	Koji           *Koji           `json:"koji,omitempty"`
}

// ComposeSBOMs defines model for ComposeSBOMs.
type ComposeSBOMs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// The SBOM documents for each image built in the compose.
	Items [][]ImageSBOM `json:"items"`
}

// ComposeStatus defines model for ComposeStatus.
type ComposeStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageStatus   ImageStatus        `json:"image_status"`
	ImageStatuses *[]ImageStatus     `json:"image_statuses,omitempty"`
	KojiStatus    *KojiStatus        `json:"koji_status,omitempty"`
	Status        ComposeStatusValue `json:"status"`
}

// ComposeStatusError defines model for ComposeStatusError.
type ComposeStatusError struct {
	Details *interface{} `json:"details,omitempty"`
	Id      int          `json:"id"`
	Reason  string       `json:"reason"`
}

// ComposeStatusValue defines model for ComposeStatusValue.
type ComposeStatusValue string

// Container defines model for Container.
type Container struct {
	// Name to use for the container from the image
	Name *string `json:"name,omitempty"`

	// Reference to the container to embed
	Source string `json:"source"`

	// Control TLS verifification
	TlsVerify *bool `json:"tls_verify,omitempty"`
}

// ContainerUploadOptions defines model for ContainerUploadOptions.
type ContainerUploadOptions struct {
	// Name for the created container image
	Name *string `json:"name,omitempty"`

	// Tag for the created container image
	Tag *string `json:"tag,omitempty"`
}

// ContainerUploadStatus defines model for ContainerUploadStatus.
type ContainerUploadStatus struct {
	// Digest of the manifest of the uploaded container on the registry
	Digest string `json:"digest"`

	// FQDN of the uploaded image
	Url string `json:"url"`
}

// CustomRepository defines model for CustomRepository.
type CustomRepository struct {
	Baseurl        *[]string `json:"baseurl,omitempty"`
	CheckGpg       *bool     `json:"check_gpg,omitempty"`
	CheckRepoGpg   *bool     `json:"check_repo_gpg,omitempty"`
	Enabled        *bool     `json:"enabled,omitempty"`
	Filename       *string   `json:"filename,omitempty"`
	Gpgkey         *[]string `json:"gpgkey,omitempty"`
	Id             string    `json:"id"`
	Metalink       *string   `json:"metalink,omitempty"`
	Mirrorlist     *string   `json:"mirrorlist,omitempty"`
	ModuleHotfixes *bool     `json:"module_hotfixes,omitempty"`
	Name           *string   `json:"name,omitempty"`
	Priority       *int      `json:"priority,omitempty"`
	SslVerify      *bool     `json:"ssl_verify,omitempty"`
}

// Customizations defines model for Customizations.
type Customizations struct {
	Cacerts    *CACertsCustomization `json:"cacerts,omitempty"`
	Containers *[]Container          `json:"containers,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will be used to depsolve and retrieve packages. Additionally,
	// these packages will be saved and imported to the `/etc/yum.repos.d/` directory
	// on the image
	CustomRepositories *[]CustomRepository `json:"custom_repositories,omitempty"`
	Directories        *[]Directory        `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo        *FDO          `json:"fdo,omitempty"`
	Files      *[]File       `json:"files,omitempty"`
	Filesystem *[]Filesystem `json:"filesystem,omitempty"`

	// System FIPS mode setup
	Fips *FIPS `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *FirewallCustomization `json:"firewall,omitempty"`

	// List of groups to create
	Groups *[]Group `json:"groups,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale   `json:"locale,omitempty"`
	Openscap *OpenSCAP `json:"openscap,omitempty"`
	Packages *[]string `json:"packages,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *CustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will only be used to depsolve and retrieve packages
	// for the OS itself (they will not be available for the build root or
	// any other part of the build process). The package_sets field for these
	// repositories is ignored.
	PayloadRepositories *[]Repository      `json:"payload_repositories,omitempty"`
	Rhsm                *RHSMCustomization `json:"rhsm,omitempty"`
	Rpm                 *RPMCustomization  `json:"rpm,omitempty"`
	Services            *Services          `json:"services,omitempty"`
	Subscription        *Subscription      `json:"subscription,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`
	Users    *[]User   `json:"users,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type CustomizationsPartitioningMode string

// DNFPluginConfig defines model for DNFPluginConfig.
type DNFPluginConfig struct {
	Enabled *bool `json:"enabled,omitempty"`
}

// DepsolveRequest defines model for DepsolveRequest.
type DepsolveRequest struct {
	Architecture string        `json:"architecture"`
	Blueprint    Blueprint     `json:"blueprint"`
	Distribution string        `json:"distribution"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// DepsolveResponse defines model for DepsolveResponse.
type DepsolveResponse struct {
	// Package list including NEVRA
	Packages []PackageMetadata `json:"packages"`
}

// A custom directory to create in the final artifact.
type Directory struct {
	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the directory as a group name or a gid
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the directory in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the directory
	Path string `json:"path"`

	// Owner of the directory as a user name or a uid
	User *interface{} `json:"user,omitempty"`
}

// Error defines model for Error.
type Error struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Code        string       `json:"code"`
	Details     *interface{} `json:"details,omitempty"`
	OperationId string       `json:"operation_id"`
	Reason      string       `json:"reason"`
}

// ErrorList defines model for ErrorList.
type ErrorList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []Error `json:"items"`
}

// FIDO device onboard configuration
type FDO struct {
	DiMfgStringTypeMacIface *string `json:"di_mfg_string_type_mac_iface,omitempty"`
	DiunPubKeyHash          *string `json:"diun_pub_key_hash,omitempty"`
	DiunPubKeyInsecure      *string `json:"diun_pub_key_insecure,omitempty"`
	DiunPubKeyRootCerts     *string `json:"diun_pub_key_root_certs,omitempty"`
	ManufacturingServerUrl  *string `json:"manufacturing_server_url,omitempty"`
}

// System FIPS mode setup
type FIPS struct {
	// Enables the system FIPS mode
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom file to create in the final artifact.
type File struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// Filesystem defines model for Filesystem.
type Filesystem struct {
	// size of the filesystem in bytes
	MinSize    uint64 `json:"min_size"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type FirewallCustomization struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
}

// Firewalld services to enable or disable
type FirewallServices struct {
	// List of services to disable
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable
	Enabled *[]string `json:"enabled,omitempty"`
}

// Bind a list of network sources to a zone to restrict traffic from
// those sources based on the settings of the zone.
type FirewallZones struct {
	// name of the zone, if left empty the sources will apply to
	// the default zone.
	Name *string `json:"name,omitempty"`

	// List of sources for the zone
	Sources *[]string `json:"sources,omitempty"`
}

// GCPUploadOptions defines model for GCPUploadOptions.
type GCPUploadOptions struct {
	// Name of an existing STANDARD Storage class Bucket.
	Bucket *string `json:"bucket,omitempty"`

	// The name to use for the imported and shared Compute Engine image.
	// The image name must be unique within the GCP project, which is used
	// for the OS image upload and import. If not specified a random
	// 'composer-api-<uuid>' string is used as the image name.
	ImageName *string `json:"image_name,omitempty"`

	// The GCP region where the OS image will be imported to and shared from.
	// The value must be a valid GCP location. See https://cloud.google.com/storage/docs/locations.
	// If not specified, the multi-region location closest to the source
	// (source Storage Bucket location) is chosen automatically.
	Region string `json:"region"`

	// List of valid Google accounts to share the imported Compute Engine image with.
	// Each string must contain a specifier of the account type. Valid formats are:
	//   - 'user:{emailid}': An email address that represents a specific
	//     Google account. For example, 'alice@example.com'.
	//   - 'serviceAccount:{emailid}': An email address that represents a
	//     service account. For example, 'my-other-app@appspot.gserviceaccount.com'.
	//   - 'group:{emailid}': An email address that represents a Google group.
	//     For example, 'admins@example.com'.
	//   - 'domain:{domain}': The G Suite domain (primary) that represents all
	//     the users of that domain. For example, 'google.com' or 'example.com'.
	// If not specified, the imported Compute Engine image is not shared with any
	// account.
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// GCPUploadStatus defines model for GCPUploadStatus.
type GCPUploadStatus struct {
	ImageName string `json:"image_name"`
	ProjectId string `json:"project_id"`
}

// Group defines model for Group.
type Group struct {
	// Group id of the group to create (optional)
	Gid *int `json:"gid,omitempty"`

	// Name of the group to create
	Name string `json:"name"`
}

// Ignition configuration
type Ignition struct {
	Embedded  *IgnitionEmbedded  `json:"embedded,omitempty"`
	Firstboot *IgnitionFirstboot `json:"firstboot,omitempty"`
}

// IgnitionEmbedded defines model for IgnitionEmbedded.
type IgnitionEmbedded struct {
	Config string `json:"config"`
}

// IgnitionFirstboot defines model for IgnitionFirstboot.
type IgnitionFirstboot struct {
	// Provisioning URL
	Url string `json:"url"`
}

// ImageRequest defines model for ImageRequest.
type ImageRequest struct {
	Architecture string       `json:"architecture"`
	ImageType    ImageTypes   `json:"image_type"`
	Ostree       *OSTree      `json:"ostree,omitempty"`
	Repositories []Repository `json:"repositories"`

	// Size of image, in bytes. When set to 0 the image size is a minimum
	// defined by the image type.
	Size *uint64 `json:"size,omitempty"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions *UploadOptions `json:"upload_options,omitempty"`

	// The type and options for multiple upload targets. Each item defines
	// a separate upload destination with its own options. Multiple
	// different targets as well as multiple targets of the same kind are
	// supported.
	UploadTargets *[]UploadTarget `json:"upload_targets,omitempty"`
}

// ImageSBOM defines model for ImageSBOM.
type ImageSBOM struct {
	// The name of the osbuild pipeline which has the packages described
	// in the SBOM installed.
	PipelineName string `json:"pipeline_name"`

	// The purpose of the pipeline. The `buildroot` pipeline was used for
	// the build environment dueing the image build. The `image` pipeline
	// represents the actual content of the image. Due to the nature of
	// some image types, there may be multiple pipelines of the same
	// purpose.
	PipelinePurpose ImageSBOMPipelinePurpose `json:"pipeline_purpose"`

	// The SBOM document in the 'sbom_type' format.
	Sbom interface{} `json:"sbom"`

	// The type of the SBOM document. Currently only SPDX is supported.
	SbomType ImageSBOMSbomType `json:"sbom_type"`
}

// The purpose of the pipeline. The `buildroot` pipeline was used for
// the build environment dueing the image build. The `image` pipeline
// represents the actual content of the image. Due to the nature of
// some image types, there may be multiple pipelines of the same
// purpose.
type ImageSBOMPipelinePurpose string

// The type of the SBOM document. Currently only SPDX is supported.
type ImageSBOMSbomType string

// ImageStatus defines model for ImageStatus.
type ImageStatus struct {
	Error          *ComposeStatusError `json:"error,omitempty"`
	Status         ImageStatusValue    `json:"status"`
	UploadStatus   *UploadStatus       `json:"upload_status,omitempty"`
	UploadStatuses *[]UploadStatus     `json:"upload_statuses,omitempty"`
}

// ImageStatusValue defines model for ImageStatusValue.
type ImageStatusValue string

// ImageTypes defines model for ImageTypes.
type ImageTypes string

// ImportKeys defines model for ImportKeys.
type ImportKeys struct {
	Files *[]string `json:"files,omitempty"`
}

// Installer defines model for Installer.
type Installer struct {
	SudoNopasswd *[]string `json:"sudo-nopasswd,omitempty"`
	Unattended   *bool     `json:"unattended,omitempty"`
}

// Kernel defines model for Kernel.
type Kernel struct {
	// Appends arguments to the bootloader kernel command line
	Append *string `json:"append,omitempty"`

	// Name of the kernel to use
	Name *string `json:"name,omitempty"`
}

// Koji defines model for Koji.
type Koji struct {
	Name    string `json:"name"`
	Release string `json:"release"`
	Server  string `json:"server"`
	TaskId  int    `json:"task_id"`
	Version string `json:"version"`
}

// KojiLogs defines model for KojiLogs.
type KojiLogs struct {
	Import interface{} `json:"import"`
	Init   interface{} `json:"init"`
}

// KojiStatus defines model for KojiStatus.
type KojiStatus struct {
	BuildId *int `json:"build_id,omitempty"`
}

// List defines model for List.
type List struct {
	Kind  string `json:"kind"`
	Page  int    `json:"page"`
	Size  int    `json:"size"`
	Total int    `json:"total"`
}

// LocalUploadOptions defines model for LocalUploadOptions.
type LocalUploadOptions map[string]interface{}

// LocalUploadStatus defines model for LocalUploadStatus.
type LocalUploadStatus struct {
	ArtifactPath string `json:"artifact_path"`
}

// Locale configuration
type Locale struct {
	// Sets the keyboard layout
	Keyboard *string `json:"keyboard,omitempty"`

	// List of locales to be installed, the first one becomes primary, subsequent ones are secondary
	Languages *[]string `json:"languages,omitempty"`
}

// OCIUploadOptions defines model for OCIUploadOptions.
type OCIUploadOptions map[string]interface{}

// OCIUploadStatus defines model for OCIUploadStatus.
type OCIUploadStatus struct {
	Url string `json:"url"`
}

// OSTree defines model for OSTree.
type OSTree struct {
	// A URL which, if set, is used for fetching content. Implies that `url` is set as well,
	// which will be used for metadata only.
	Contenturl *string `json:"contenturl,omitempty"`

	// Can be either a commit (example: 02604b2da6e954bd34b8b82a835e5a77d2b60ffa), or a branch-like reference (example: rhel/8/x86_64/edge)
	Parent *string `json:"parent,omitempty"`
	Ref    *string `json:"ref,omitempty"`

	// Determines whether a valid subscription manager (candlepin) identity is required to
	// access this repository. Consumer certificates will be used as client certificates when
	// fetching metadata and content.
	Rhsm *bool   `json:"rhsm,omitempty"`
	Url  *string `json:"url,omitempty"`
}

// ObjectReference defines model for ObjectReference.
type ObjectReference struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`
}

// OpenSCAP defines model for OpenSCAP.
type OpenSCAP struct {
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// OpenSCAPJSONTailoring defines model for OpenSCAPJSONTailoring.
type OpenSCAPJSONTailoring struct {
	Filepath  string `json:"filepath"`
	ProfileId string `json:"profile_id"`
}

// OpenSCAPTailoring defines model for OpenSCAPTailoring.
type OpenSCAPTailoring struct {
	Selected   *[]string `json:"selected,omitempty"`
	Unselected *[]string `json:"unselected,omitempty"`
}

// Package defines model for Package.
type Package struct {
	// Name of the package to install. File globbing is supported,
	// eg. 'openssh-*'
	Name string `json:"name"`

	// Optional version of the package to install. If left blank the
	// latest available version will be used. Wildcards are supported
	// eg. '4.11.*'
	Version *string `json:"version,omitempty"`
}

// PackageDetails defines model for PackageDetails.
type PackageDetails struct {
	Arch        string  `json:"arch"`
	Buildtime   *string `json:"buildtime,omitempty"`
	Description *string `json:"description,omitempty"`
	Epoch       *string `json:"epoch,omitempty"`
	License     *string `json:"license,omitempty"`
	Name        string  `json:"name"`
	Release     string  `json:"release"`
	Summary     *string `json:"summary,omitempty"`
	Url         *string `json:"url,omitempty"`
	Version     string  `json:"version"`
}

// PackageGroup defines model for PackageGroup.
type PackageGroup struct {
	// Package group name
	Name string `json:"name"`
}

// PackageMetadata defines model for PackageMetadata.
type PackageMetadata struct {
	Arch string `json:"arch"`

	// Optional package checksum using ALGO:HASH form
	Checksum  *string `json:"checksum,omitempty"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Sigmd5    *string `json:"sigmd5,omitempty"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// PulpOSTreeUploadOptions defines model for PulpOSTreeUploadOptions.
type PulpOSTreeUploadOptions struct {
	// Basepath for distributing the repository
	Basepath string `json:"basepath"`

	// Repository to import the ostree commit to
	Repository    *string `json:"repository,omitempty"`
	ServerAddress *string `json:"server_address,omitempty"`
}

// PulpOSTreeUploadStatus defines model for PulpOSTreeUploadStatus.
type PulpOSTreeUploadStatus struct {
	RepoUrl string `json:"repo_url"`
}

// RHSMConfig defines model for RHSMConfig.
type RHSMConfig struct {
	DnfPlugins          *SubManDNFPluginsConfig `json:"dnf_plugins,omitempty"`
	SubscriptionManager *SubManConfig           `json:"subscription_manager,omitempty"`
}

// RHSMCustomization defines model for RHSMCustomization.
type RHSMCustomization struct {
	Config *RHSMConfig `json:"config,omitempty"`
}

// RPMCustomization defines model for RPMCustomization.
type RPMCustomization struct {
	ImportKeys *ImportKeys `json:"import_keys,omitempty"`
}

// Repository configuration.
// At least one of the 'baseurl', 'mirrorlist', 'metalink' properties must
// be specified. If more of them are specified, the order of precedence is
// the same as listed above.
type Repository struct {
	Baseurl  *string `json:"baseurl,omitempty"`
	CheckGpg *bool   `json:"check_gpg,omitempty"`

	// Enables gpg verification of the repository metadata
	CheckRepoGpg *bool `json:"check_repo_gpg,omitempty"`

	// GPG key used to sign packages in this repository.
	Gpgkey     *string `json:"gpgkey,omitempty"`
	IgnoreSsl  *bool   `json:"ignore_ssl,omitempty"`
	Metalink   *string `json:"metalink,omitempty"`
	Mirrorlist *string `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool `json:"module_hotfixes,omitempty"`

	// Naming package sets for a repository assigns it to a specific part
	// (pipeline) of the build process.
	PackageSets *[]string `json:"package_sets,omitempty"`

	// Determines whether a valid subscription is required to access this repository.
	Rhsm *bool `json:"rhsm,omitempty"`
}

// SSHKey defines model for SSHKey.
type SSHKey struct {
	// Adds the key to the user's authorized_keys file
	Key string `json:"key"`

	// User to configure the ssh key for
	User string `json:"user"`
}

// SearchPackagesRequest defines model for SearchPackagesRequest.
type SearchPackagesRequest struct {
	Architecture string `json:"architecture"`
	Distribution string `json:"distribution"`

	// Array of package names to search for. Supports * wildcards for
	// names, but not for versions.
	Packages     []string      `json:"packages"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// SearchPackagesResponse defines model for SearchPackagesResponse.
type SearchPackagesResponse struct {
	// Detailed package information from DNF
	Packages []PackageDetails `json:"packages"`
}

// Services defines model for Services.
type Services struct {
	// List of services to disable by default
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable by default
	Enabled *[]string `json:"enabled,omitempty"`

	// List of services to mask by default
	Masked *[]string `json:"masked,omitempty"`
}

// SubManConfig defines model for SubManConfig.
type SubManConfig struct {
	Rhsm      *SubManRHSMConfig      `json:"rhsm,omitempty"`
	Rhsmcertd *SubManRHSMCertdConfig `json:"rhsmcertd,omitempty"`
}

// SubManDNFPluginsConfig defines model for SubManDNFPluginsConfig.
type SubManDNFPluginsConfig struct {
	ProductId           *DNFPluginConfig `json:"product_id,omitempty"`
	SubscriptionManager *DNFPluginConfig `json:"subscription_manager,omitempty"`
}

// SubManRHSMCertdConfig defines model for SubManRHSMCertdConfig.
type SubManRHSMCertdConfig struct {
	AutoRegistration *bool `json:"auto_registration,omitempty"`
}

// SubManRHSMConfig defines model for SubManRHSMConfig.
type SubManRHSMConfig struct {
	ManageRepos *bool `json:"manage_repos,omitempty"`
}

// Subscription defines model for Subscription.
type Subscription struct {
	ActivationKey string `json:"activation_key"`
	BaseUrl       string `json:"base_url"`
	Insights      bool   `json:"insights"`
	Organization  string `json:"organization"`

	// Optional flag to use rhc to register the system, which also always enables Insights.
	Rhc       *bool  `json:"rhc,omitempty"`
	ServerUrl string `json:"server_url"`
}

// Timezone configuration
type Timezone struct {
	// List of ntp servers
	Ntpservers *[]string `json:"ntpservers,omitempty"`

	// Name of the timezone, defaults to UTC
	Timezone *string `json:"timezone,omitempty"`
}

// Options for a given upload destination.
// This should really be oneOf but AWSS3UploadOptions is a subset of
// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
// are also valid AWSS3UploadOptionas objects which violates the oneOf
// rules. Therefore, we have to use anyOf here but be aware that it isn't
// possible to mix and match more schemas together.
type UploadOptions interface{}

// UploadStatus defines model for UploadStatus.
type UploadStatus struct {
	Options interface{}       `json:"options"`
	Status  UploadStatusValue `json:"status"`
	Type    UploadTypes       `json:"type"`
}

// UploadStatusValue defines model for UploadStatusValue.
type UploadStatusValue string

// UploadTarget defines model for UploadTarget.
type UploadTarget struct {
	Type UploadTypes `json:"type"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions UploadOptions `json:"upload_options"`
}

// UploadTypes defines model for UploadTypes.
type UploadTypes string

// User defines model for User.
type User struct {
	Groups *[]string `json:"groups,omitempty"`
	Key    *string   `json:"key,omitempty"`
	Name   string    `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`
}

// Page defines model for page.
type Page string

// Size defines model for size.
type Size string

// PostComposeJSONBody defines parameters for PostCompose.
type PostComposeJSONBody ComposeRequest

// PostCloneComposeJSONBody defines parameters for PostCloneCompose.
type PostCloneComposeJSONBody CloneComposeBody

// PostDepsolveBlueprintJSONBody defines parameters for PostDepsolveBlueprint.
type PostDepsolveBlueprintJSONBody DepsolveRequest

// GetErrorListParams defines parameters for GetErrorList.
type GetErrorListParams struct {
	// Page index
	Page *Page `json:"page,omitempty"`

	// Number of items in each page
	Size *Size `json:"size,omitempty"`
}

// PostSearchPackagesJSONBody defines parameters for PostSearchPackages.
type PostSearchPackagesJSONBody SearchPackagesRequest

// PostComposeJSONRequestBody defines body for PostCompose for application/json ContentType.
type PostComposeJSONRequestBody PostComposeJSONBody

// PostCloneComposeJSONRequestBody defines body for PostCloneCompose for application/json ContentType.
type PostCloneComposeJSONRequestBody PostCloneComposeJSONBody

// PostDepsolveBlueprintJSONRequestBody defines body for PostDepsolveBlueprint for application/json ContentType.
type PostDepsolveBlueprintJSONRequestBody PostDepsolveBlueprintJSONBody

// PostSearchPackagesJSONRequestBody defines body for PostSearchPackages for application/json ContentType.
type PostSearchPackagesJSONRequestBody PostSearchPackagesJSONBody

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// The status of a cloned compose
	// (GET /clones/{id})
	GetCloneStatus(ctx echo.Context, id string) error
	// Create compose
	// (POST /compose)
	PostCompose(ctx echo.Context) error
	// The status of a compose
	// (GET /composes/{id})
	GetComposeStatus(ctx echo.Context, id string) error
	// Clone an existing compose
	// (POST /composes/{id}/clone)
	PostCloneCompose(ctx echo.Context, id string) error
	// Download the artifact for a compose.
	// (GET /composes/{id}/download)
	GetComposeDownload(ctx echo.Context, id string) error
	// Get logs for a compose.
	// (GET /composes/{id}/logs)
	GetComposeLogs(ctx echo.Context, id string) error
	// Get the manifests for a compose.
	// (GET /composes/{id}/manifests)
	GetComposeManifests(ctx echo.Context, id string) error
	// Get the metadata for a compose.
	// (GET /composes/{id}/metadata)
	GetComposeMetadata(ctx echo.Context, id string) error
	// Get the SBOMs for a compose.
	// (GET /composes/{id}/sboms)
	GetComposeSBOMs(ctx echo.Context, id string) error
	// Depsolve one or more blueprints
	// (POST /depsolve/blueprint)
	PostDepsolveBlueprint(ctx echo.Context) error
	// Get a list of all possible errors
	// (GET /errors)
	GetErrorList(ctx echo.Context, params GetErrorListParams) error
	// Get error description
	// (GET /errors/{id})
	GetError(ctx echo.Context, id string) error
	// Get the openapi spec in json format
	// (GET /openapi)
	GetOpenapi(ctx echo.Context) error
	// Search for detailed information on a list of package names
	// (POST /search/packages)
	PostSearchPackages(ctx echo.Context) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetCloneStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetCloneStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetCloneStatus(ctx, id)
	return err
}

// PostCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCompose(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCompose(ctx)
	return err
}

// GetComposeStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeStatus(ctx, id)
	return err
}

// PostCloneCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCloneCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCloneCompose(ctx, id)
	return err
}

// GetComposeDownload converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeDownload(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeDownload(ctx, id)
	return err
}

// GetComposeLogs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeLogs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeLogs(ctx, id)
	return err
}

// GetComposeManifests converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeManifests(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeManifests(ctx, id)
	return err
}

// GetComposeMetadata converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeMetadata(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeMetadata(ctx, id)
	return err
}

// GetComposeSBOMs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeSBOMs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeSBOMs(ctx, id)
	return err
}

// PostDepsolveBlueprint converts echo context to params.
func (w *ServerInterfaceWrapper) PostDepsolveBlueprint(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostDepsolveBlueprint(ctx)
	return err
}

// GetErrorList converts echo context to params.
func (w *ServerInterfaceWrapper) GetErrorList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Parameter object where we will unmarshal all parameters from the context
	var params GetErrorListParams
	// ------------- Optional query parameter "page" -------------

	err = runtime.BindQueryParameter("form", true, false, "page", ctx.QueryParams(), &params.Page)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter page: %s", err))
	}

	// ------------- Optional query parameter "size" -------------

	err = runtime.BindQueryParameter("form", true, false, "size", ctx.QueryParams(), &params.Size)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter size: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetErrorList(ctx, params)
	return err
}

// GetError converts echo context to params.
func (w *ServerInterfaceWrapper) GetError(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetError(ctx, id)
	return err
}

// GetOpenapi converts echo context to params.
func (w *ServerInterfaceWrapper) GetOpenapi(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetOpenapi(ctx)
	return err
}

// PostSearchPackages converts echo context to params.
func (w *ServerInterfaceWrapper) PostSearchPackages(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostSearchPackages(ctx)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/clones/:id", wrapper.GetCloneStatus)
	router.POST(baseURL+"/compose", wrapper.PostCompose)
	router.GET(baseURL+"/composes/:id", wrapper.GetComposeStatus)
	router.POST(baseURL+"/composes/:id/clone", wrapper.PostCloneCompose)
	router.GET(baseURL+"/composes/:id/download", wrapper.GetComposeDownload)
	router.GET(baseURL+"/composes/:id/logs", wrapper.GetComposeLogs)
	router.GET(baseURL+"/composes/:id/manifests", wrapper.GetComposeManifests)
	router.GET(baseURL+"/composes/:id/metadata", wrapper.GetComposeMetadata)
	router.GET(baseURL+"/composes/:id/sboms", wrapper.GetComposeSBOMs)
	router.POST(baseURL+"/depsolve/blueprint", wrapper.PostDepsolveBlueprint)
	router.GET(baseURL+"/errors", wrapper.GetErrorList)
	router.GET(baseURL+"/errors/:id", wrapper.GetError)
	router.GET(baseURL+"/openapi", wrapper.GetOpenapi)
	router.POST(baseURL+"/search/packages", wrapper.PostSearchPackages)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x9eXPbOLL4V0HpN1WZvOg+LNlVU/tk+ZJvWz5ir1JeiIQoWCTAAKBkeV6++69wkCIl",
	"6oqTmc2u/9idWMTRaDQafePPjEU9nxJEBM/s/JnxIYMeEoiZvxwk/2sjbjHsC0xJZidzCR0EMLHRSyab",
	"QS/Q812UaD6CboAyO5lS5tu3bAbLPl8DxCaZbIZAT35RLbMZbg2QB2UXMfHl71wwTBzVjePXlLnPA6+H",
	"GKB9gAXyOMAEIGgNgBkwDk04QARNsbgQHtV2GTzfwo9q6OZ9Z79VbrmUoJZEH1cTQdvGEkzoXjLqIyaw",
	"BKQPXY6yGT/2058Zhhy1nrmJshk+gAw9jbEYPEHLooHZGLOyzM4/M6VypVrbqje2i6Vy5ks2ozCROpb5",
	"ATIGJ2rtDH0NMEO2HMbA8CVqRnvPyBKyn17fre9SaF8o1PPvXmAEeAYFuTHiIlfKZP/KZWcznECfD6h4",
	"0rsdh8mb5MKv81ClIywd1lVo7AgoAn1KEoiCHk5CBD2cK1qNSrG+XanXa7Xtml3tpWFsQxTPLEbOm11B",
	"A53KW0jAD3outvQR7sPAFVG75JFu9wFHAggK1GfwuxggYLoAdXg/ZgEELiVOFtBeP+AWFMgGt9enXYI5",
	"YEgEjCA7D9qCA/TiYwbl0MDDzkCAHgKcUoIYEANIQJ8yQMUAMRCotXWJgMxBgue7pEumsAgWIDktH1Am",
	"EJOzgdhkABK7S3ByQsyBhJ1DDwHI1VTy7/h0YDrbdIt6lLoIkrdv6nrbuYgUA+ams+L4FLJR6vivAUNv",
	"IZfBxEfsafTkIII0PhOkk7mTy09STmtAKUcKx3dnoO3Je+lIDnMHpqNkgY37fcQQEaCPoAgY4oASoAAG",
	"UP5vBLELey7qEhv5iNiYOLKFHHduOL1xiASexIYC6q4cw8j0fGIJT8RyZq4xSSK0r6bQhIFsoDpIKgZe",
	"wBXhBgR/DeRdqxo6eIQIYIjTgFkIOIwGfl7RrJxEUh/1sJBHo8+op7rInUNcSEJmkNjUA5Qg0IMc2XKF",
	"ENzetvcA5l1iVohss8A4h1SApbEgl1qxnYov8NR8CRfpMzrCcpEh+E8K/CwYDxDTW6hmkectcG21+BAv",
	"kMhuDuYCMQXfER3LI+piLgB0XRCCwXe6ZCCEz3cKBZtaPO9hi1FO+yJvUa+ASC7gBcvFBSj3vmB49z9G",
	"GI3/UD/lLBfnXCgQF/8PvobM/UlO9BRN8kGhXEIc/iRRT6gA3EcW7mNkZwEW8kcb2YGV2JAFeJhFujzv",
	"KJDnI53zx/sup64kuayB7llQbmhgQXJthjlUM6bd30EvAuEJ2/NAtfckSPFm3wFMFdXsRq9s5WCvXM1V",
	"q6VKbrto1XJbpXKluIUaxW1UToNOIAKJWAKXBEI3Wg8qQ4J9TGy11/qEap5ySZmA7jq0GNKhwCOUszFD",
	"lqBsUugHxIYeIgK6fO5rbkDHOUFzcuqcBnkGSTWrjvq13lauZFX6uaoNizm4VS7nir3iVrFc2bbrdn3l",
	"VTLF2PzezlHgigth0YWT5JDrsJwZIGMDpIGw6wbIZ5iIDa8iixIBMTFK0MydE37T1MElFSCvJ9k3kWLD",
	"AEmigC6ATPShJaXKSFD9jaF+Zifz/wpTnatgtIpCNG6aAGsFXFAPv8LoYl02VLTsVrLbt5n7M0VytjEX",
	"jM6v+kaKZPIb7gXq6AoKAo4iEcfSWlAetPvARX0BkOeLifo0oFx0iR4YjLHrqpPE5892H9mUwVxlO+0A",
	"KzrjabqoNZSHVH+XYPXkfckFdF1kr4t8M4pmbin496gdGK0yOX2TAOhiI+v5ehSelVKi3Etb/dyD1nAM",
	"mc0VlqCAPexiMVGr3wS6NMDCszOHrxCWhRh7K67SoBkhxlOlgSbgyBshBkwLQJQan9j+er6erxdXHvnV",
	"h701d1g2OfrQQkysPq3NlmyWmEqfH82lcRrm96YfJfIthqCIhLuIaeBNuEY45CRtO/o2XdX/YO9CtcSp",
	"1H0gf/5RoEb7I0dNBVfONuECeSnipBT1aB9M2wBPimY+xUTEQPwuYMykqSCl8Zx9IpUFcNC+7ACP2ihV",
	"ketjhsbQdTeAxHQIud1iLEyZ3WarXsjfJI9OV1RalPSxo3SmkJmrhmn6jkNweLEsg6IdtlO2OMV91Pl5",
	"stEIWyuUpXgHoDtkgRUwqd65E0CJO5GXSz9wo7sJ2Q7Kcez5rpLNcyHHY0AuYeYSKthoVOA2TF1g2HHl",
	"CqOG37KZIWIErSSDE93K6FQuWtX+VLf6ls1QHxFuQX9tQrvwEem0mpf6mmBCbQYmzpOi5YTODQNBc+7I",
	"m9O8O8hFlgADKQVr0WBopOXwho9GRnYefAgH+qC/S9GBwTEIiIs47xKhRG6pi0v1lDLgUYYSJxxLbQFb",
	"A2BBjqTEHY1zeneWBx/U2NAdwwnvkoAjLn/PAiQ15vEAKcZlpiAUoBfBYHz8PPjA4PgDUD0lZBH4vEvS",
	"BlkAZ9I6wOA4k81o/EWo/JKq0PmU40X3xnXsqzz0Y4YFkv8oIGEVJoGXV/3zdiHJoY094ZwKJFEMhfzG",
	"QyQIJYQBKEAvwK4NBPZQfn2hJCKnCLrUO4gNuLdqqOujztncTcr81f0u57txxCRPWAl+J2wn+/DBEE0W",
	"s1vOB2CIJnxd1HQ6RycoFRsSx6+UrDzdN2G7b9lMwDXDSYdNfn3L/XfL0zSOb8vkK3V/p4h4WklRV/Qq",
	"mUHTWVLysqGA6eqWhDzk/2p0yIHvQjkyehELtYX5wdT9NzsSBA625VmGxkRi7rfpncCocg5Qgi76mZ1/",
	"zkvb0S+YCORIhH7RSkOa8wwxD3MpBHOgB4guKgURJoBaAqrry4MiAUhxq1pNW64PxSBN0BcDEKmkbnJN",
	"inV4E/P73IjpRHcxJtr3lsRfEOJP9vpB6JuR+tUKv6yiyqn0mCQtD5N0b6L8Nb4eI1piAnoTgXh8GeVS",
	"tV5tVLaqjWzmJefQnAElwERsVbWSGF4DSWtGYQTZSrUm1jkbwbtiwVMBc6mCMyvT6242sIxop3nnnPeG",
	"GjUone+oz+B3qfVSJgCDxEH8ozLV+owKalFXsSUpncTR+M9MubwjLD+TzTSK5h/Yg77652ZOvTU5fbjg",
	"OMeXvFVboNZhluEIj6rXZswyErbmiFLyOy4Ygl7qcp85JU8CYpeqX1aAGE5z3Lk4v4k6SdZAXWxNUg2f",
	"l4GQpzcyWgPdFrT3QqYtL2Yg+TXPAi4ZCRQAkokWwoklRaXILA8E7RJJt85A8EgKlFKPBwW2oOtOJMUR",
	"pOzhhi3JlbhYDhVObma2KOHUNfKI4YQ7mSBQxsd5/seoPL1mlfOUsykWYxic5UPTmZYezphQNLfxPchR",
	"wNwk/U3ZRWg0tmySZ8geQG0wtvRFWLAxFwU2QG6j0Ci8NLaetqoFOSLlBcoLCWwxnGoKnzlHSGmzccwl",
	"tFgXLbQxOb5jDZA1TO/q+I4SmuKrXAnMgh30kIAuJsN0THmYMcp4XhsQfUblduQpcwphv39IAfmP0MBY",
	"7gbFYnkLMmvwh8bgGmjTk7iYi3kgIhjk57yFiKBczf8PhlwEOfqjkdNHPTYzlP+/VdW/KPh2IUcXnXVg",
	"UebIpwEVffySbmniclM5UC0hw2Ii7zeBYvKGcmaHVLrIHb3YvsgwlcPGPka3t9ZnnpaTB+fuCDHcn6R9",
	"njXzrzhtt0Za2cDOt8oQ7qRxTC0/Yju0fks+iKAdShCh3pxNwcgi+3VTezFpH0yBj9l3oG1rH7GUrASN",
	"i/dTElTNS+uc9QFNs/HcmAk+cCAbgMjVlDZkqqYkNSQd7iEVpYT0x/kgh+xyrVbaBs1ms9mqnL/CVsl9",
	"3GuXzm/2a/K39jk7PNlnZw/409nZ7Tg4gtfNY+/6lLZfr/vlr3tle6/2Wty9eSlsvaTBNO9BkssppYvK",
	"nI8pS/MDGke1aQC4gEzdZGIAftv6LQt+q/2WlXLub+Xeb5EFoocAF1Tef5B3CSQAEYtNfHnHhSPlwYUY",
	"IDbGMcNFDwGh9CNbi9BTdaZLon7xMxkPlEJa6Jt1uDuYAPXRkGeqXJ9G1vL4fA9Vr2uZTzWWbxhLhLyn",
	"yDAfEyZzudzu/mH7HLT2r2/aB+1W82Y/l8t1u+Ss3W4V91qtZg87zXF7t+m0b9v5fL7bJblcbv98b6bL",
	"GwLppsClrj4WJbhLbXV6prrQMnEkJcpQKZbxX64R9ykx8Yeuu8aoFwqya6RCYiyk9K8Zt6ydPEylcgVV",
	"a1v1HGps93Klsl3JwWptK1ctb23VatVqsVgsrhbT1uHp0eqmHuPvX9Sy9gm/tJ5W47Nt/wdhUi/plDr8",
	"hy5KOd2V0TBVujMgJNVkyTRYH1roz29pF9OQPuOVJnL6jNVa0qMADEBLUXEGCe4jLn4oPrz4oG9Hxqxh",
	"IBp9+cqQgKEF7UctjEqZFT1Z1POwSA2c+X0A+eBjeFPIHRDANM9+h09ay0KYWG6gYvDO9++umxv6pSNE",
	"rKGnx/B3rQPlVl5LhAod3jzdoZngjGymF4WdfPk2e5H14iEpa1loN4//SAn7iIVuJDmS1CRzjczC8EU2",
	"xctSj5dsHOJwtvP6lpbZYb6XTcydogQCYtve2b04+7HMMVzmvIgt5wI2tQJPGbSlFqZSF7TfTB+eyPyh",
	"w2nitL/WgNMwUeP82Z/OEPBAWWEGSlIVQGqmAogxVQPxrPJphYNonxAiI8wokeMr016sRZdASwTQBcYw",
	"ETlo1bzrHlq14XL6VG/JMr6oh1/KE3+EEJF29fFo3NVLMxJGNtEVbXgipqOkHYg14ZHnYjrQen0SiLxT",
	"eTSz+2AGSi5wnX3ZZ4yyFLMoEhAr49isOShhX4A8VXGfF42ixnMA6PVIbmjctTywLMTlWvoQuwGTGpQJ",
	"B5cLium0UcM5rjkN45tb2ZJI8LloujDGMIobXhiCreMw05zGhoynttZw0DBiMemlUZZcNsmbn5TRUc26",
	"I6CTalxw+dPUhDPvtmPUBTenHaDa4D62QkdDNKnKsVhl/DELTFWtwiW9Je9gybZE+2FUdSsZ+zkTOkK5",
	"YpqpqIJOCguHzoYz6Mj0VIVgFW5ivHADIxl2zN0/a16Uv4ccP5RQ5/IZposxyRQhjaUbNkz6yYy76mrv",
	"PD1RYgY3XwM4yWNa8CYmar9g9mNnCdZmE1uy4ZJTqU2JVWtY9v9NDPvK+Prk+E66AVZ/Di216W3e5Bsw",
	"lsJ34/9PN/7/MLs95+7TW63yf2f4bTJw/0fF3T8tD8/aV8Fk8TaJaPCYgxUTkNTk8uBmgDjqkkTveJC8",
	"vKxt5HPqjpBJhBIMoxGKxs+DZoRfd5JVwXR8+nlqpoYjk0uFPZ+ymBf2X3NxZP+a+gC6xDDvKdNdD6+z",
	"3DIFvTPR0n9LxPOaEQDrhCyvPdTqgOOlI7QvO5tEGIfhC3OnZZFP6t8qzDieFfQeffzLRh8ng46ndsCY",
	"L8enXDgM8c3CgN4jmP8tIph9OJHC+d9yVapjt/Z92SXh0bzoACw4cvuq5MBED0aoyryOcsJnLGKMUgEo",
	"6xJIJiaxXyI6bgJXEXAW4vyjgjmc+IkjwUEfI9cOx5xbDuYAO4SyMDluLXb7HxCAHcsvXdkv3vYNIdXr",
	"X/7rh0jvnR9cuoGDib7O5hXEJfpU6niGkNd1TsxUFmHWAAtkiYDNREdEes/cMf4+98T3uBdmGcWbSX1G",
	"O5muZAa+bBIxXxJ4njrTZ+IP/nbXVTIa2kCTpn9NBeTFMfqRdP89gfqI8IChJx+ysGjU8vou+6o9CBNQ",
	"gO4IYsI/QC84bqGJRxGuEck/XY0O54+i+E1UP7b/lnD+KVhLY/rrtdr3xfTHw7TmAvttzL4zrn8Gm1FM",
	"vwnx/xHIXDe4P3IR/Cj/jWX2cD7vPe51kD1grI5FCu9az/1g6eRQ03xm4HQXiVryqTE0rbds1XqJJ3It",
	"FqRR/Ranm1SsN0xFaO9dGC0KUNKjkK1KSrDxk9d3njS6nyQQTx60niSrWrCvOCBPftB7GqLJ0wDywepW",
	"mHBkmStzeUtJ+9OotHlDHSSB5KGBAlbKRYg9LayxNEf8Ss3fDKEdnb4SJSYDjoSq1rJQClnFuXUUsSpq",
	"NTN2JruWCPMLJIv9xPtshafrPVHtvydRbUV+2tOvlqD2tDBDLd3e+J6ltmGW2rclqO3ERv0urIZgqVgA",
	"Xc6CMmDrtJGUa5fHbozUFOnYeNNRYvgUyCVIbIa7xD21albdODlpX8iNI8LfMLh7Id4fw7zBDZC+i4kN",
	"YJTmQZAYUzYEOqxBJ3mAV0rUNciQhMoSQDDY72NLxX90iRhQjqIeUfU+dS0jITBxoitPjpR2Yaab3UnM",
	"ti17ZgGeq98UTqusY9D33YlK9YsX6ZxOuiA8ZckRDYcP7xZlo1kY9tYNisWKpfuof6N/FvRvHuRD/cuX",
	"/9O/nDVb+of/wz5HYkf/qv6tf1/tRE+jhcPW5VvCTXqBNURisZsBEi09yPu2c9M832te74GOoAw6CFgu",
	"5BzsqiHys1UazR85M8OGFSlvBkireTOxSJGzUDJNVfjWBi3q+YFAYJ84mIQhf11yE5XMUwPNFLEcYzEw",
	"8t1h6xIYT33WGMUxV+bbpHFWhy3quqlTx6UqMpYotxhVt+ySDyZ0kuWgj3N6y4MA23rHP4SSjJlOigUi",
	"AfUm1S+ntVrnUSmXqL/H6glGawpdDHFPbAy/8tQbfKr6txEqofwb22r0sPhkHnQQAlFwiUsDO+9Q6pgQ",
	"Lq5JR9UgLEQ1LE3Z0GTNShXME7gC5wzkUX1Ly6UccREKaeb8kd9NacmQPDVhRt0+SjRbkneRZCLwLJJR",
	"sEFF6HQ2YvCi1g3C5hJeNUqSktPIV5FnvktUvKwhEoV1E1IQS5SOBEszjXLk5cGdgkALwxxAhna6BIAc",
	"+CCFzZ0/kQexi+1vH3ZAkwD1F4C2zRDnWpVgyGeIK/UlmsuSQ4CZZeXBAWXAYC8LPkAXW+h/Y2F7H/Jm",
	"ZnM/NnW/DWHQU5shFs3tTXLKCZKDvv+/0Pe5T0XeMZ3CPnGQlOayKTbM+sNKqRKuGRTYHiY8FQc29SAm",
	"O3/q/8oJ1fEEnQALBPSv4HefYQ+yycf5yV1XTxhmYZqbFgrTdxYj06P3QYpUH2ZgSj91y0kzrC6rmYNK",
	"SIRk0iUhfrszsqsiuDmqyETCaEgP625exuipO/NozmQzBsHxH39KTfro3v1x1UTV3SzHf5pN1ILcQsSG",
	"ROR6DGI7VylWaqXKSiUpNlx2VXHSw1D130B4WJ6VbNiSNg5MjSq/U18P/zE1M3l1geqZAb+/RGM7FqOx",
	"gQQddluhC6qYZlvrC+tEgOyH7XUsDRc9SsW6nQ+iDqlC4twcGxegNf7DVQZm1W4Zrg/iK9sAhNRo3EtG",
	"R5jrYAtwe326VlBtKnTxRJ+f79bUR1H/vEa+xc3E145pnQG3MralcyNb/QynZvwZFGOTLM5ZfY2NSC0y",
	"G9mG8uB+gEj4nEExXtBadsDyYvUwwV7gdYmN+qpebW8Sa6fkmuTlUi1vV7e36uXtrUVGJi2uP1F/rVS1",
	"pCY17W5eSUiXreWcOh1J91O6ihJcfRfNvrNgMqAE8oBeJO8SCDjyIZPM0bS2kdS4tLCrLlgsOKBjEk6R",
	"B2dm/C6ZPidg5pBaxBhJ7ZhPwQi/GR6q3oQYKlMAQ13CA1/f+BvEeWhc3ahxV16kiVOSOAAzVPolPI0q",
	"C2ve8Y195GKyUms0yzQx9yDsZrS7gdGzokAfPUpPKnxGJ1TJbFEx4nzqZR3C4gcsfHNnHhzzMXp4wHTS",
	"sTj/UuAxSsW/YjBCow32KdOGjfnsNztAkudND4dqYgZVv0wHVEE9oQCpFYXFmXJgL4hSdIh6nQLQfpdw",
	"6sWPIc+ayC0PqlCniMzCOROE1iUGCflYKFe08pAcUuO4eI96a2Qbhp6aD7K9oqsPRvWJ7dw6uc9R/yVH",
	"3awsAUAetJJhl53Lvc+SqU1PVmzt3LdfUpY7m2nU01JyBFJ2hvxTSHB6fBZIpSj0Ya+dZxe5YjfOMzQZ",
	"ehEXXW+AZC2Emc4b3GOz4yzlT2GeYBJ9G6XkZTVJ639qoPW/w6JkJm9vjsZjd3xsKjiW08Axzw1gjg0C",
	"bP6K/ZNDP/rzVQOjnw1B0K8nviT/iPVT4cBRirz5K8xAMD9MI32zGUf5HhwrGsCRIlOk0Kj/JjpgKnJS",
	"3IM9Nzm0/BBNrP9IfpwdhcHxdB4qUoOYM9mMi0dJCJRQAd2cjh2lloR6xH3Jvqb/ytERzGQzY+4u2CJ5",
	"iE9M/bDkiZoP3f8OK247Hk2dHJ8HNs0Rqsrw2JtlMAUECoGIvX6I30kUn72JCOzLM5DiVle/cwCZY3LC",
	"zcUiCULlzjGgA8JVlQYpQklmlrDFEco98UefMgstK7W0WFs0E0Q1iKZD6y85G/UCZ70kxhOT7/8d6ZzT",
	"aQ905lfLpYGd24V8gS1X5Wole5aL5WJxu1jPF1PtkyqiIz0rbUifcUpKmvx5EPTWSeaDfDhrlaiW0/T3",
	"2KMLUzgqq98KM+BPpzKbOx1xipUvC/YmLC0za4iRh9dkcBNVOmQukIhoNqRbLhp+0Z2q+P462EmjqTC4",
	"KjmkFM0XPKThoAXJckYzm/8iqIBu2qcZLKhJs9FjmPoNSt05uzDWKqve1nI380EtG2Phy4Qm/uYpjNpY",
	"8aBgovlCuNGGxh/daYXpZ4gmKnxsnjN1kJHBwybAhRMaJMNVgtRUfhcSJ0gP+g29DjpbZu4playJ12Cy",
	"FUGghyzqIQ6MlTmrXsFCXwOlDEjZHTIEOLIosaHJjo6ZcxF5uu3kb28Oco23+rEvWu030k00wk95RNBY",
	"Unb+THmQCRGRapNqqqcZlZ6p3NcciWzk3+tTBvpIWAOpvJlR8qAtBRlkPA3/Cpj7L6U5IBFq8tku0Ypr",
	"IhVTmRlMjLZSOhb4vHVAWEp4GiRyLIRV2gg0lZLA72avd0CxvFWs9so23ELbtWrPrlR7jV6jDBuVGqrB",
	"et0u97aK/T78mNVhTD0GiTXIuXiIAIvqPUzHYwPkTpPJpWz5ccbzNt8i/XLsz4f1r9HNpJ4sD6fbQwIx",
	"T6mw4wEyqNHuvMRjcR4k0EEM/G5BYrvIx+QjwDYiAouJfplT05eKToBKbZircgpalPDAQwxYkrhUTYrZ",
	"hFvIgeVieTSTbQaIdElESxEdSCEqJKwFRVTXj/mcjWCeOwgDsxXzFs7022vBtZZWJsVcRmqG1LO5sJL1",
	"e6nqX7BUdfo2pCpbC+7/FYtZDE52OuoyyJZAxVXyJtpYO/uefmnnNHwD7YdVmgmNlSaZSNBQmMiDA+wi",
	"4Li01zOBK5GFK9slyMmDDyoHlw9y//NhhrsLL0itl7vwnbYL4ymM3mlbAlf40l/PhWSoK4LpSiux3Mlw",
	"mMSzf+Aeu7alHsRTck+4HLOaar5Uys8tpZKvwO93PJr92ouyPFJ8SqmkoDQNgb1FWSPLi0gjny4Y18UW",
	"MolmC1XsZTpqyvOrnhQtU7+l3z8JMlgDr2l6oc6lW4by7/Fyp5+TxEuP88HbkEAlP+cEpS5/M6nE62mu",
	"SSuqoA4PvCXHKjxHYVMQcHmom6eHFztHzc6RsqEny2cPYLm2tVMr1+qNho0qtl2tVrfrVrluV0v1cm2r",
	"Udna6pWLlUYRbvW26sV6vwhL2/VitV5BVVv+YwtW+6l5Dwup8/soEDueXVv0Sbs2lrDbt9CnMdavJFO5",
	"vYHray3jTUGckKP0XIZd80UpC9O8U+M6moqiS1NiJ0veAFMpm9puYjxugiEU6hKqRPwCS9WTCbBS1/pS",
	"89NsKm242tTzMoPQRXqhKjS1lnIYtUybTqWqL8iutkn/yVf513yNLPIzSKJ8bW6GnH3H2ugc640WjvFt",
	"Ediz+RCLYj5Wpuovm+hy1Tyadp7CtzmWu5YiK3z6ZOsRbMJ2k++SZlh7VJWg0BLGB1M77UMWfJiW01J/",
	"mTJeH8B0HSo0s0t6aKoSKIFEFbPQI3pauEjG2VFm6/BNnyEL2Updxrp6h/bQQ64C9aUa2KOj1Ej6WJG3",
	"v66228a13NZL7HN8x5RnTL7WP+VEkaK7QLed1nmbCUq7PARDNIlqcsgrYOr+V6pTUjVP3Hq5XFTY//Lw",
	"Elze7p62W+Bk/wHsnl60TtTnLukS76p9vnvYtDoW3d1v7p32Gw9HQ/R6vAVt9+xhXIeHh233GLqicfxc",
	"finslk8+Ddr9dvByKPy75zrqktNrZ++2vvUMb2r+3V7NOzg7rvhDRNB1wbrxvn69Gp5Prvjgc5lefR7v",
	"v952eqXW+Vmr3zp0hp8bV+UueX0csrbVYgfFq/KYnfRcGNiD20/4DpLmHvdKjYf9r7xXa95W6ra4ZWeV",
	"qwf73tm+/vQZX/bvGtddcrL7fFOsjO52L+yzDn+obJ/CFtlq+6WLkd9o79NCG+3fPZS+eq2LyyY8KfaO",
	"jypB36m2AjTkn246XTK+ur9BrdOX4PF06+LsM724PBmPzq76Lz2n9HmvMQoeiyfiuWCdH5VfYFB88Xgz",
	"2D469tFwdHF5/eJ2yeSreJ489hm9w+hg4o8fndHVWBBy1ig4nf2gcHx3wx6KtbK3f3tTb1m9enVoHR3c",
	"HPTPhi4ZHha6pNi/rTavYa1YPaq8PBeHoocqoxPr8jO9vAhOdu/4UWdULN4ePjQnlyiYfGrUrdvCw/7g",
	"rD6sdO5OnrtkC7UfnQk+uyiO3dLD4d71iRW44yHfbn4K3KFToje9Kq+8eo+jy2L9kN683FfLz/Ckdt/5",
	"dD54RKhLGlvFz/Ru0LNKJ37n03P/kT5zti8eG5e928dPD6ODxrXP7Psmez7qHQ/Lx/71SfPlZvDCr5p8",
	"d3BY6pLiafBSvodnu0Wn3K5dWmf2ccH6+kyLDctiz7ufA/xyz3ANB9tnn/3G15tCv/N67nG77ZBG4evj",
	"SZfgxlXg9oN6Pfg6uC+MRbknCBbONf/6PHg5C54fbquPvepgKA4ag5PbwufP9Wr56+C0djJuXjevmrtd",
	"IvYODh/vr0eWt++c7J2VTjrNxqN3N+xVjgenN2el08+7E3hfGljEbYa/W0fHI+jdPdut2qhLLM/6hK+O",
	"L3Z3z3ZbzWb1AO/vo6Mtjw0OjurBHb86PTsrFx9q1uOAvDw0DpqeOkOtw3HjoDUetrtkd9w+PLiix60m",
	"b+3uPrSa4/3WkbPfOqg2my1neDXt/en8oVmo7z74jjvpNB8fjgbPk5NBlxQ+9bdeL/t3o95Rubj/tTJs",
	"1y8Ods+L5PTzp93bkheMOp++3gSdyv0p2614lcPAFf7J9f7xyanwavt7XVJih6+fm/SmNPG3H9qN0+ae",
	"fdZqXUyem8+c3t826g+3QetToUee2Q26Lp9eX7T6k8tWfet+u1HDF3dd4tU6n3r8am9cb5VPmWs3z6pn",
	"ewGdPJY6WBzCx+rJ1emd+HSzD0tVzB86h63nV1q/fGjcVY4vhrVilzhf751G+bzQ88r7r536TaNyv7/X",
	"K7mj52rbHb047a8nyCmVXj8/vHjsofN4fNzqj177n9zzzlbw4hx1yfNL4bg4cR/Lp7h3yLYOm83Jxfbt",
	"PWs+dsads+K+9XzTGO+3yMuwsxdMvnr347vR+e7nYL9917hAlYcuOcO3pf7xeYPb9T2fH7zUzj59tskZ",
	"uep8OmLPN5cnexXvnrlNm+zfDOyHu8bz49C/H+xNeKWwvY0uumQwLLJTMik+n4+HMOgX8G3jwtr6PDob",
	"Pp9enx07tdvtu5PJcXB/L17Hn8nz2Xnt/vpg9+tJlT9S7+ysS/qid3NU+lSb9K7vC83KaLcHX67vy6J+",
	"+3r+bL2iYedxH8PT8+3TwpF13Gpfl64OGluN8p7ddPcPtu0uGZadK/zQuWpCeFw8Pm6+Ho2uh9fHp6fO",
	"Sfnh6gEfnd9NyqJyPDnocwa92rjTur/oDy5Re3K6e/N43CUj5p+7lz3U5zfbtfpNv7x73g6c10fWqt29",
	"7HVOho/O9aB0dzjqtK9Ia/I6vJps7d+Wv176+L62LXnU4LL9+ZGdUOukcnLa2S7g1+Orm2tXPJ81/+iS",
	"Py77N3X1PIx+IGbJ1bOgAh1l6IlzN/2Sfq9juvoRs6WOgh/1qFm8IFeqPU6OF6rqumqXcrfEpCLIpUDD",
	"gVK5Yvk6qhhYl/wexol9TC0MNpexERaOphsWv/uxHpakEwUs8KGsWfjBPIK8mV6dKko2bTty4YbWePNc",
	"GQzEgDL8imylz8xXD1jr9bFm5x6L4cVR9bZRr+7bfPeWTESv0huPrh3nyL1yew+f3TopFUfbCypXpxYh",
	"uNVvtkXqj85CM49JS5JK2q9sD5PV8fRchWxIPKVpxx0kz6MxYfG/Lr7+ewqALS6p1ZTkrbQ0cwYJ9LST",
	"nav1SdzlQUfbjTn4HzCODMoqglc1z4JeIFTelDy8xibEZ8KtVx+wn1ylLELC6iJls3u7eakybf5WL9Np",
	"vGKimbQ8/Oqlgb3zgw1rloUm9TeVLFu7nMEPKEsAepPYk3YpZdrDsrp2+gVK2rpL6YfUK1gJDemrSE6+",
	"MTAe5MN1YZFtV0KiKzhsipXUqyFuLps3FK5RsFKPELeF6bvQQkzYG3SWzZdZ0xaYCefPHKN2EKURLi1f",
	"PVMi8jstjnPDLIZ+dqHzDo1A0CfzNAOc8WUtv+Jnd2En5Wk0/Q6UT/kGoya8ajPAWgKPdA01IywkEj05",
	"shgSOf0IaSSBRo9+plW8hBw9pdrz5s15a0i1YVhBYrhF1Z8ocyCJGWrjkafVYqVcTY+qsVaLfJHHqe9C",
	"JyzpwAaWLjKiAyFiZb3CKgzQ5dTUIDYMioO2WdGM0LpoTck6Z/E3c6bbmpdnNYbYlXiduUwSeMvO0kQC",
	"htgGxzYn7RK6iRWS3SA+Mey2IkKRCF9DtSSakAgfhI0S6kExTygTgxz0EMMWzPuUunkifKmeZbKZ0rLP",
	"G+kT8WK6i6MUwlbZ8MJQl8jtTSsh0N52CvtQ0hlZL9Z73h9HJms/kjqbR7iyT6eyWZe5qi8r53gNGNqs",
	"y4LnjFZ1SwkHXtVlLg50VYdFbtNvX9I5T6gy67fo5pMsVXUTzAEf0MC1AUMq6KqnqpJf9JXoPr9JOmdV",
	"xc4KlSSXsvd5oMb1ECQmvhO6LkhpCDTl8S6BDGnGp1XiuXlh1NZwyRGmKtJFu5QkwF3CAhfpGuUM9SlD",
	"WTBGYABHUT0dRc1A5fDJ1fUQgGMYlhHEAmBOPogu8SnnuKeLInr4RYUXelBYA+3bMvsBBHWUIi+ZcnR2",
	"FrleY7m4mzw8PJPPtfaRWrPHbD2HDQ7Umj3Sn8Ba+2ys2X6BA3yDUxt/hnjzlL0o6W+d9HaTQ6zz2xe9",
	"5GfCKUKy+TJDYBsm6bGAkEWZeImU5jm63XhBb8w+T48qmRnyy8Kra3FGYZ5XolS+MHEwnn1HLZw3LEZX",
	"UpIIDFw/b+oPmGc50lFobE+bVBGJ3n1JUfPUx9I674vNyd/vT/2/7an/NfSV9aLYlBhuBQyLSUeSut72",
	"XQSZppWe+tdBON3x/Y0UmlVLKczrdtGoUhfKfPumlJs+TUux0SWiBDVWblWqTYeJ6hR2ns8kQh71Jmaa",
	"PrQGCJRVep1SGCJvyHg8zkP1WbkgTF9eOG239s87+7lyvpgfCM/VQqtQhHDR2VXTm2RqBlQtNAB9HAsK",
	"28mUw2dr5IedTCVfzJcyujStQlPBcilBvPAntr+p05JWre8Q6egrzTNV3T5gGJ2kGxUsjkT4VKE2rsHo",
	"WV8j/OjXAmJWecqUwXJaZEAV3MGUAMVika2z2qMy4m1bgxJ/Ml+ln0APCaVq/DPl0e6wVEgIvKDAUfUC",
	"MVG0JwZhLN1O+IBqSHFa6dPs86e8bP9FzqYtm2ozysViLP/H5L66Jlql8GyqsE8BWioOxLCkyDmJmThO",
	"JIlUf+DUJqV/ftI20UKnoQyAbT116edP3QxU1eUhUo4frAHRs1d+/uy3ZOq7kRToIyZpA0S0rSGp/hWQ",
	"DAkdk5ktqP0Vu39L0Iuvs0xUmQhALfWYmJ1g4eoUh8z7n1/kGYmivVWRjDgTUswroic1TiH8Q9VLTnvP",
	"taULhUFA0DjsmgU+lUvHYToMN0VJle14hBgMmbvi90bFUw+aax8dZnGFj88zrkvKheHVhskgLnapPflx",
	"Jz75tv+35PUpmdm3OX5T+tGzt+20rTcfVWUcJX4g+29jOmz64P4753nnPGtyHsM00jjNjxKeNpCXQhyu",
	"EJTidXbWE5Wigf/LhKUEplIoKImXd4HpnW39ogLTQv6lFcG41JQiv8gmUyFmDX4SY1b/RlzkJ8heMcyo",
	"gf9q6Ss2fxQsk0JSqoIhGk9LLfdUoT9d6naBTCbQiygoO04SnlnUrs29qj9qgrSz+S1xa0u0JB4ZWHIA",
	"bDomUqxfeJPvmQaKqqMHm/TB6mOC+SB2iy+5kMNxNruSBQX2tOMvdyFTSyBhQmqT2xzN08MEpuUKppNx",
	"VJMifENBe98i/L/f0e939C9xRyfYSsRVtEd5Ss3z/Mo15ci+R+uYY1dgqc6BxVTVyCoLiHIhyyOYCKuE",
	"PRoIk1PHA1cs44Kqmtq7UrJSKVF4WsADJQmk8z9VGZtQ/S66FbiQmYq14HcxoIEzMP7/487F+cf8f9zF",
	"f6geZnH4GsfIgwT3ERerz1LUco3jdI1EwAhXSb9hPwWMshka8YuYo6LkUVO7O2psUXWwoqqWZvvC2uVQ",
	"gLj7yJSi1ik0kBTM37lwuHxtyVE8i1Dwfh5XnscpshYJJvHtXlcw+cXPWvJ4rHHoYgVHlp+5qAJdqpSt",
	"n41CL/LGjF9ETB0/ZAMb6SKxNHHWIlelKvq/7GSEcL4fjNUHI3rQ/V1gfxfY/4MF9jnetJrf8R71FgsY",
	"obAAgY71TBb/5yvkhi6ZaQ5Z1Ea9EzB9qmChi2D34mzDy1/CpANENZsD4Rj/Ja4CtdoFnE59/G+7/qeL",
	"nj0KNvI5dUeo0HMD5DPzIvNiM/Oeab8bNf85Rttwno085sWfMP1ie23YZprFqNLZ/+qrMtzBd+f5/IX5",
	"y5iZwj1UdaiYjrCPTqQOCC6oweMX1dyNoUA81Q/+z1wXaSubNimowu+LAsVj7VRl+J/Kw6drSCO56PFq",
	"g4x3Wv97hENN6L+eaDh9/Ry6LohSXEJqmh6z1XEjkEQlnUNvqoZsWhu6NwFKBko/qOt7aZFp/ibxrfIX",
	"C2MLt1J9APHf3k/x+yne5BSjeQqSJzcKpV98Q16YJm+k+9ksh7mFGlAUL5D6nhzC6Hq/oja9dDkS9boc",
	"SiFe8WOxDpGsH/KTFIj0AjR/sRqxoFJKymbpliCERGcAhXqFPS1t8peqFjwE6l2x+EUVi05UpsgQEbIT",
	"tnhKYiJRosiRBiiqFDAnnZyZ1+pVuRFMyUcQPeOVTKCCPs6rdwEGuK+LV0AfF/RzgcoPhljO2CRYYVRW",
	"WsjM2RDQwcRZNgEX0EFvnMbSz3ia1/SjaVaN8+Xb/w8AAP//d7WTxrreAAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
